#include <tee_internal_api.h>

#ifndef KEY_PAIR_H
#define KEY_PAIR_H

TEE_Result kp_create(
	TEE_ObjectHandle *kp);

TEE_Result kp_serialize(
	TEE_ObjectHandle kp,
	char *serilized, uint32_t *serilized_sz);

TEE_Result kp_deserialize(
	char *serilized, uint32_t serilized_sz,
	TEE_ObjectHandle *kp);

TEE_Result kp_encrypt(
	TEE_ObjectHandle kp,
	void *in,  uint32_t  in_sz,
	void *out, uint32_t *out_sz);

TEE_Result kp_decrypt(
	TEE_ObjectHandle kp,
	void *in,  uint32_t  in_sz,
	void *out, uint32_t *out_sz);

#endif /*KEY_PAIR_H*/